HSR	equ	$ffe9	;Host Status Register
HRX	equ	$ffeb	;Host Receive Register
HTX	equ	$ffeb	;Host Transmit Register
PBC	equ	$ffe0	;Port B Control register
BCR	equ	$fffe	;Bus Control Register

rec	MACRO	dest
	jclr	#0,x:<<HSR,*
	movep	x:<<HRX,dest
	ENDM

env	MACRO	source
	jclr	#1,x:<<HSR,*
	movep	source,x:<<HTX
	ENDM


	org p:$0
	jmp	start
	dup	62
	nop
	endm

start
	movep	#$0,x:BCR		;0 WS
	movep	#1,x:PBC		;Port B en mode HOST
	
	
toto	
	move	#>$123456,x0
	move	x0,p:INTERN	
	move	x0,p:ERROR0	
	move	x0,p:ERROR1
	move	x0,p:ERROR2	

	
	move	#>0,b
	jsr	TEST_INTERNAL
	move	#>$ffffff,b
	jsr	TEST_INTERNAL
	move	#>$aaaaaa,b
	jsr	TEST_INTERNAL
	move	#>$555555,b
	jsr	TEST_INTERNAL


	move	#>0,b
	jsr	TEST_SRAM
	move	#>$ffffff,b
	jsr	TEST_SRAM
	move	#>$aaaaaa,b
	jsr	TEST_SRAM
	move	#>$555555,b
	jsr	TEST_SRAM

	env	#'DSP'	
	env	p:INTERN
	env	p:ERROR0
	env	p:ERROR1
	env	p:ERROR2
	jmp	*
	
		

TEST_SRAM
	move	#$200,r0
	move	#1,n0
	clr	a	
	move	#>16384-512-256,x1
	.LOOP	x1
	move	b,x:(r0)
	move	x1,x:(r0+n0)
	move	x:(r0)+,a
	cmp	b,a
	jeq	okx
	jsr	ERROR
okx	
	nop
	.ENDL
	nop
	
	rts
	

	
ERROR
	move	a1,y0
	clr	b	b1,y1
	move	#>$56789a,x1

	move	#>$ff0000,x0
	move	y0,a
	move	y1,b
	and	x0,a	
	and	x0,b
	cmp	a,b
	jeq	_ok0
	move	x1,p:ERROR0
_ok0	

	move	#>$ff00,x0
	move	y0,a
	move	y1,b
	and	x0,a	
	and	x0,b
	cmp	a,b
	jeq	_ok1
	move	x1,p:ERROR1
_ok1	

	move	#>$ff,x0
	move	y0,a
	move	y1,b
	and	x0,a	
	and	x0,b
	cmp	a,b
	jeq	_ok2
	move	x1,p:ERROR2
_ok2
	move	y1,b1
	rts
	

	
TEST_INTERNAL
	move	#0,r0
	clr	a	#>$56789a,y1

	.LOOP	#$100

	move	b,x:(r0)	
	move	x:(r0),a
	cmp	b,a
	jeq	_ok0
	move	y1,p:INTERN
_ok0	move	b,y:(r0)
	move	y:(r0)+,a
	cmp	b,a
	jeq	_ok1
	move	y1,p:INTERN
_ok1
	nop
	.ENDL
	nop
	rts
	
INTERN	dc	0
ERROR0	dc	0
ERROR1	dc	0
ERROR2	dc	0
	